/*Copyright (C) 2010-2012 Duncan Deveaux

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Graphics/Window.hpp"
#include "Audio/Audio.hpp"

#include "Configuration/Configuration.hpp"
#include "Engines/GameEngine.hpp"

int main()
{
    SDL_Init(SDL_INIT_VIDEO);
    Audio::init();
    
    Configuration confManager;
    confManager.load();
    
    Window window("Hikou no mizu", confManager.getWindowWidth(), confManager.getWindowHeight(), 32, confManager.getFullscreen());
    window.initView(1024, 576);
    
    GameEngine gameEngine(window, confManager);
    gameEngine.initMainMenu();
    
    while (!gameEngine.wasExited())
    {
        gameEngine.launchNextScreen();
    }
    
    confManager.save();
    
    Audio::close();
    SDL_Quit();
    return 1;
}
